Index: src/view/WaveTrackV.cpp
===================================================================
--- src/view/WaveTrackV.cpp	(revision 0)
+++ src/view/WaveTrackV.cpp	(working copy)
@@ -0,0 +1,1020 @@
+#include "../Audacity.h"
+#include "../TrackArtist.h"
+#include "../AllThemeResources.h"
+
+#undef PROFILE_WAVEFORM
+#ifdef PROFILE_WAVEFORM
+   #ifdef __WXMSW__
+      #include <time.h>
+   #else
+      #include <sys/time.h>
+   #endif
+double gWaveformTimeTotal = 0;
+int gWaveformTimeCount = 0;
+#endif
+
+WaveTrackV::WaveTrackV(void):
+TrackV()
+{
+}
+
+WaveTrackV::~WaveTrackV(void)
+{
+}
+
+void WaveTrackV::DrawWaveform(WaveTrack *track,
+                               wxDC & dc,
+                               const wxRect & r,
+                               const ViewInfo *viewInfo,
+                               bool drawEnvelope,
+                               bool drawSamples,
+                               bool drawSliders,
+                               bool dB,
+                               bool muted)
+{
+   DrawBackgroundWithSelection(&dc, r, track, blankSelectedBrush, blankBrush,
+         viewInfo->sel0, viewInfo->sel1, viewInfo->h, viewInfo->zoom);
+
+   for (WaveClipList::compatibility_iterator it = track->GetClipIterator(); it; it = it->GetNext())
+      DrawClipWaveform(track, it->GetData(), dc, r, viewInfo,
+                       drawEnvelope, drawSamples, drawSliders,
+                       dB, muted);
+
+   // Update cache for locations, e.g. cutlines and merge points
+   track->UpdateLocationsCache();
+   
+   for (int i = 0; i<track->GetNumCachedLocations(); i++) {
+      WaveTrack::Location loc = track->GetCachedLocation(i);
+      double x = (loc.pos - viewInfo->h) * viewInfo->zoom;
+      if (x >= 0 && x < r.width) {
+         dc.SetPen(*wxGREY_PEN);
+         AColor::Line(dc, (int) (r.x + x - 1), r.y, (int) (r.x + x - 1), r.y + r.height);
+         if (loc.typ == WaveTrack::locationCutLine) {
+            dc.SetPen(*wxRED_PEN);
+         }
+         else {
+            dc.SetPen(*wxBLACK_PEN);
+         }
+         AColor::Line(dc, (int) (r.x + x), r.y, (int) (r.x + x), r.y + r.height);
+         dc.SetPen(*wxGREY_PEN);
+         AColor::Line(dc, (int) (r.x + x + 1), r.y, (int) (r.x + x + 1), r.y + r.height);
+      }
+   }
+}
+
+void WaveTrackV::DrawClipWaveform(WaveTrack *track,
+                                   WaveClip *clip,
+                                   wxDC & dc,
+                                   const wxRect & r,
+                                   const ViewInfo *viewInfo,
+                                   bool drawEnvelope,
+                                   bool drawSamples,
+                                   bool drawSliders,
+                                   bool dB,
+                                   bool muted)
+{
+#if PROFILE_WAVEFORM
+#   ifdef __WXMSW__
+   __time64_t tv0, tv1;
+   _time64(&tv0);
+#   else
+   struct timeval tv0, tv1;
+   gettimeofday(&tv0, NULL);
+#   endif
+#endif
+   double h = viewInfo->h;          //The horizontal position in seconds
+   double pps = viewInfo->zoom;     //points-per-second--the zoom level
+   double sel0 = viewInfo->sel0;    //left selection bound
+   double sel1 = viewInfo->sel1;    //right selection bound
+   double trackLen = clip->GetEndTime() - clip->GetStartTime();
+   double tOffset = clip->GetOffset();
+   double rate = clip->GetRate();
+   double sps = 1./rate;            //seconds-per-sample
+
+   //If the track isn't selected, make the selection empty
+   if (!track->GetSelected() && !track->IsSyncLockSelected()) {
+      sel0 = sel1 = 0.0;
+   }
+
+   //Some bookkeeping time variables:
+   double tstep = 1.0 / pps;                  // Seconds per point
+   double tpre = h - tOffset;                 // offset corrected time of
+                                              //  left edge of display
+   double tpost = tpre + (r.width * tstep);   // offset corrected time of
+                                              //  right edge of display
+
+   // Determine whether we should show individual samples
+   // or draw circular points as well
+   bool showIndividualSamples = (pps / rate > 0.5);   //zoomed in a lot
+   bool showPoints = (pps / rate > 3.0);              //zoomed in even more
+
+   // Calculate actual selection bounds so that t0 > 0 and t1 < the
+   // end of the track 
+
+   double t0 = (tpre >= 0.0 ? tpre : 0.0);
+   double t1 = (tpost < trackLen - sps * .99 ? tpost : trackLen - sps * .99);
+   if (showIndividualSamples) {
+      // adjustment so that the last circular point doesn't appear
+      // to be hanging off the end
+      t1 += 2. / pps;
+   }
+
+   // Make sure t1 (the right bound) is greater than 0
+   if (t1 < 0.0) {
+      t1 = 0.0;
+   }
+
+   // Make sure t1 is greater than t0
+   if (t0 > t1) {
+      t0 = t1;
+   }
+
+   // Calculate sample-based offset-corrected selection 
+
+   // Use the WaveTrack method to show what is selected and 'should' be copied, pasted etc.
+   sampleCount ssel0 = wxMax(0, track->TimeToLongSamples(sel0 - tOffset));
+   sampleCount ssel1 = wxMax(0, track->TimeToLongSamples(sel1 - tOffset));
+
+   //trim selection so that it only contains the actual samples
+   if (ssel0 != ssel1 && ssel1 > (sampleCount)(0.5 + trackLen * rate)) {
+      ssel1 = (sampleCount)(0.5 + trackLen * rate);
+   }
+
+   // The variable "mid" will be the rectangle containing the
+   // actual waveform, as opposed to any blank area before
+   // or after the track.
+   wxRect mid = r;
+
+   dc.SetPen(*wxTRANSPARENT_PEN);
+
+   // If the left edge of the track is to the right of the left
+   // edge of the display, then there's some blank area to the
+   // left of the track.  Reduce the "mid"
+   if (tpre < 0) {
+      double delta = r.width;
+      if (t0 < tpost) {
+         delta = (int) ((t0 - tpre) * pps);
+      }
+      mid.x += (int)delta;
+      mid.width -= (int)delta;
+   }
+
+   // If the right edge of the track is to the left of the the right
+   // edge of the display, then there's some blank area to the right
+   // of the track.  Reduce the "mid" rect by the
+   // size of the blank area.
+   if (tpost > t1) {
+      wxRect post = r;
+      if (t1 > tpre) {
+         post.x += (int) ((t1 - tpre) * pps);
+      }
+      post.width = r.width - (post.x - r.x);
+      mid.width -= post.width;
+   }
+
+   // The "mid" rect contains the part of the display actually
+   // containing the waveform.  If it's empty, we're done.
+   if (mid.width <= 0) {
+#if PROFILE_WAVEFORM
+#   ifdef __WXMSW__
+      _time64(&tv1);
+      double elapsed = _difftime64(tv1, tv0);
+#   else
+      gettimeofday(&tv1, NULL);
+      double elapsed =
+         (tv1.tv_sec + tv1.tv_usec*0.000001) -
+         (tv0.tv_sec + tv0.tv_usec*0.000001);
+#   endif
+      gWaveformTimeTotal += elapsed;
+      gWaveformTimeCount++;
+#endif
+
+     return;
+   }
+
+   // If we get to this point, the clip is actually visible on the
+   // screen, so remember the display rectangle.
+   clip->SetDisplayRect(mid);
+
+   // The bounds (controlled by vertical zooming; -1.0...1.0
+   // by default)
+   float zoomMin, zoomMax;
+   track->GetDisplayBounds(&zoomMin, &zoomMax);
+
+   // Arrays containing the shape of the waveform - each array
+   // has one value per pixel.
+   float *min = new float[mid.width];
+   float *max = new float[mid.width];
+   float *rms = new float[mid.width];
+   sampleCount *where = new sampleCount[mid.width + 1];
+   int *bl = new int[mid.width];
+   bool isLoadingOD = false;//true if loading on demand block in sequence.
+
+   // The WaveClip class handles the details of computing the shape
+   // of the waveform.  The only way GetWaveDisplay will fail is if
+   // there's a serious error, like some of the waveform data can't
+   // be loaded.  So if the function returns false, we can just exit.
+   if (!clip->GetWaveDisplay(min, max, rms, bl, where,
+                             mid.width, t0, pps, isLoadingOD)) {
+      delete[] min;
+      delete[] max;
+      delete[] rms;
+      delete[] where;
+      delete[] bl;
+      return;
+   }
+
+   // Get the values of the envelope corresponding to each pixel
+   // in the display, and use these to compute the height of the
+   // track at each pixel
+
+   double *envValues = new double[mid.width];
+   clip->GetEnvelope()->GetValues(envValues, mid.width, t0 + tOffset, tstep);
+
+   // Draw the background of the track, outlining the shape of
+   // the envelope and using a colored pen for the selected
+   // part of the waveform
+   DrawWaveformBackground(dc, mid, envValues, zoomMin, zoomMax, dB,
+                          where, ssel0, ssel1, drawEnvelope,
+                          !track->GetSelected());
+
+   if (!showIndividualSamples) {
+      DrawMinMaxRMS(dc, mid, envValues, zoomMin, zoomMax, dB,
+                    min, max, rms, bl, isLoadingOD, muted);
+   }
+   else {
+      DrawIndividualSamples(dc, mid, zoomMin, zoomMax, dB,
+                            clip, t0, pps, h,
+                            drawSamples, showPoints, muted);
+   }
+
+   if (drawEnvelope) {
+      DrawEnvelope(dc, mid, envValues, zoomMin, zoomMax, dB);
+      clip->GetEnvelope()->DrawPoints(dc, r, h, pps, dB, zoomMin, zoomMax);
+   }
+
+   delete[] envValues;
+   delete[] min;
+   delete[] max;
+   delete[] rms;
+   delete[] where;
+   delete[] bl;
+   
+   // Draw arrows on the left side if the track extends to the left of the
+   // beginning of time.  :)
+   if (h == 0.0 && tOffset < 0.0) {
+      DrawNegativeOffsetTrackArrows(dc, r);
+   }
+
+   if (drawSliders) {
+      DrawTimeSlider(track, dc, r, viewInfo, true);  // directed right
+      DrawTimeSlider(track, dc, r, viewInfo, false); // directed left
+   }
+
+   // Draw clip edges
+   dc.SetPen(*wxGREY_PEN);
+   if (tpre < 0) {
+      AColor::Line(dc,
+                   mid.x - 1, mid.y,
+                   mid.x - 1, mid.y + r.height);
+   }
+   if (tpost > t1) {
+      AColor::Line(dc,
+                   mid.x + mid.width, mid.y,
+                   mid.x + mid.width, mid.y + r.height);
+   }
+
+#if PROFILE_WAVEFORM
+#   ifdef __WXMSW__
+   _time64(&tv1);
+   double elapsed = _difftime64(tv1, tv0);
+#   else
+   gettimeofday(&tv1, NULL);
+   double elapsed =
+      (tv1.tv_sec + tv1.tv_usec*0.000001) -
+      (tv0.tv_sec + tv0.tv_usec*0.000001);
+#   endif
+   gWaveformTimeTotal += elapsed;
+   gWaveformTimeCount++;
+   wxPrintf(wxT("Avg waveform drawing time: %f\n"),
+          gWaveformTimeTotal / gWaveformTimeCount);
+#endif
+}
+
+void WaveTrackV::DrawWaveformBackground(wxDC &dc, const wxRect &r, const double env[],
+                                         float zoomMin, float zoomMax, bool dB,
+                                         const sampleCount where[],
+                                         sampleCount ssel0, sampleCount ssel1,
+                                         bool drawEnvelope, bool bIsSyncLockSelected)
+{
+   // Visually (one vertical slice of the waveform background, on its side;
+   // the "*" is the actual waveform background we're drawing
+   //
+   //1.0                              0.0                             -1.0
+   // |--------------------------------|--------------------------------|
+   //      ***************                           ***************
+   //      |             |                           |             |
+   //    maxtop        maxbot                      mintop        minbot
+
+   int h = r.height;
+   int halfHeight = wxMax(h / 2, 1);
+   int maxtop, lmaxtop = 0;
+   int mintop, lmintop = 0;
+   int maxbot, lmaxbot = 0;
+   int minbot, lminbot = 0;
+   bool sel, lsel = false;
+   int x, lx = 0;
+   int l, w;
+
+   dc.SetPen(*wxTRANSPARENT_PEN);
+   dc.SetBrush(blankBrush);
+   dc.DrawRectangle(r);
+
+   for (x = 0; x < r.width; x++) {
+      // First we compute the truncated shape of the waveform background.
+      // If drawEnvelope is true, then we compute the lower border of the
+      // envelope.
+
+      maxtop = GetWaveYPos(env[x], zoomMin, zoomMax,
+                               h, dB, true, mdBrange, true);
+      maxbot = GetWaveYPos(env[x], zoomMin, zoomMax,
+                               h, dB, false, mdBrange, true);
+
+      mintop = GetWaveYPos(-env[x], zoomMin, zoomMax,
+                               h, dB, false, mdBrange, true);
+      minbot = GetWaveYPos(-env[x], zoomMin, zoomMax,
+                               h, dB, true, mdBrange, true);
+
+      // Make sure it's odd so that a that max and min mirror each other
+      mintop +=1;
+      minbot +=1;
+
+      if (!drawEnvelope || maxbot > mintop) {
+         maxbot = halfHeight;
+         mintop = halfHeight;
+      }
+
+      // We don't draw selection color for sync-lock selected tracks.
+      sel = (ssel0 <= where[x] && where[x + 1] < ssel1) && !bIsSyncLockSelected;
+
+      if (lmaxtop == maxtop &&
+          lmintop == mintop &&
+          lmaxbot == maxbot &&
+          lminbot == minbot &&
+          lsel == sel) {
+         continue;
+      }
+
+      dc.SetBrush(lsel ? selectedBrush : unselectedBrush);
+
+      l = r.x + lx;
+      w = x - lx;
+      if (lmaxbot != lmintop - 1) {
+         dc.DrawRectangle(l, r.y + lmaxtop, w, lmaxbot - lmaxtop);
+         dc.DrawRectangle(l, r.y + lmintop, w, lminbot - lmintop);
+      }
+      else {
+         dc.DrawRectangle(l, r.y + lmaxtop, w, lminbot - lmaxtop);
+      }
+
+      lmaxtop = maxtop;
+      lmintop = mintop;
+      lmaxbot = maxbot;
+      lminbot = minbot;
+      lsel = sel;
+      lx = x;
+   }
+
+   dc.SetBrush(lsel ? selectedBrush : unselectedBrush);
+   l = r.x + lx;
+   w = x - lx;
+   if (lmaxbot != lmintop - 1) {
+      dc.DrawRectangle(l, r.y + lmaxtop, w, lmaxbot - lmaxtop);
+      dc.DrawRectangle(l, r.y + lmintop, w, lminbot - lmintop);
+   }
+   else {
+      dc.DrawRectangle(l, r.y + lmaxtop, w, lminbot - lmaxtop);
+   }
+
+   // If sync-lock selected, draw in linked graphics.
+   if (bIsSyncLockSelected && ssel0 < ssel1) {
+      // Find the beginning/end of the selection
+      int begin, end;
+      for (x = 0; x < r.width && where[x] < ssel0; ++x);
+      begin = x;
+      for (; x < r.width && where[x] < ssel1; ++x);
+      end = x;
+      DrawSyncLockTiles(&dc, wxRect(r.x + begin, r.y, end - 1 - begin, r.height));
+   }
+
+   //OK, the display bounds are between min and max, which
+   //is spread across r.height.  Draw the line at the proper place.
+
+   if (zoomMin < 0 && zoomMax > 0) {
+      int half = (int)((zoomMax / (zoomMax - zoomMin)) * h);
+      dc.SetPen(*wxBLACK_PEN);
+      AColor::Line(dc, r.x, r.y + half, r.x + r.width, r.y + half);
+   }
+}
+
+void WaveTrackV::DrawBackgroundWithSelection(wxDC *dc, const wxRect &r,
+      Track *track, wxBrush &selBrush, wxBrush &unselBrush,
+      double sel0, double sel1, double h, double pps)
+{
+   //MM: Draw background. We should optimize that a bit more.
+   //AWD: "+ 1.5" and "+ 2.5" throughout match code in
+   //AdornedRulerPanel::DoDrawSelection() and make selection line up with ruler.
+   //I don't know if/why this is correct.
+
+   dc->SetPen(*wxTRANSPARENT_PEN);
+   if (track->GetSelected() || track->IsSyncLockSelected())
+   {
+      // Rectangles before, within, after the selction
+      wxRect before = r;
+      wxRect within = r;
+      wxRect after = r;
+
+      before.width = int ((sel0 - h) * pps + 2.5);
+      if (before.GetRight() > r.GetRight()) {
+         before.width = r.width;
+      }
+
+      if (before.width > 0) {
+         dc->SetBrush(unselBrush);
+         dc->DrawRectangle(before);
+
+         within.x = before.GetRight();
+      }
+      within.width = r.x + int ((sel1 - h) * pps + 2.5) - within.x;
+
+      if (within.GetRight() > r.GetRight()) {
+         within.width = r.GetRight() - within.x;
+      }
+
+      if (within.width > 0) {
+         if (track->GetSelected()) {
+            dc->SetBrush(selBrush);
+            dc->DrawRectangle(within);
+         }
+         else {
+            // Per condition above, track must be sync-lock selected
+            dc->SetBrush(unselBrush);
+            dc->DrawRectangle(within);
+            DrawSyncLockTiles(dc, within);
+         }
+
+         after.x = within.GetRight();
+      }
+      else {
+         // `within` not drawn; start where it would have gone
+         after.x = within.x;
+      }
+
+      after.width = r.GetRight() - after.x;
+      if (after.width > 0) {
+         dc->SetBrush(unselBrush);
+         dc->DrawRectangle(after);
+      }
+   }
+   else
+   {
+      // Track not selected; just draw background
+      dc->SetBrush(unselBrush);
+      dc->DrawRectangle(r);
+   }
+}
+
+void WaveTrackV::DrawMinMaxRMS(wxDC &dc, const wxRect &r, const double env[],
+                                float zoomMin, float zoomMax, bool dB,
+                                const float min[], const float max[], const float rms[],
+                                const int bl[], bool showProgress, bool muted)
+{
+   // Display a line representing the
+   // min and max of the samples in this region
+   int lasth1 = std::numeric_limits<int>::max();
+   int lasth2 = std::numeric_limits<int>::min();
+   int h1;
+   int h2;
+   int *r1 = new int[r.width];
+   int *r2 = new int[r.width];
+   int *clipped = NULL;
+   int clipcnt = 0;
+   int x;
+
+   if (mShowClipping) {
+      clipped =  new int[r.width];
+   }
+
+   long pixAnimOffset = (long)fabs((double)(wxDateTime::Now().GetTicks() * -10)) +
+      wxDateTime::Now().GetMillisecond() / 100; //10 pixels a second
+   
+   bool drawStripes = true;
+   bool drawWaveform = true;
+
+   dc.SetPen(muted ? muteSamplePen : samplePen);
+   for (x = 0; x < r.width; x++) {
+      int xx = r.x + x;
+      double v;
+
+      v = min[x] * env[x];
+      if (mShowClipping && v <= -MAX_AUDIO) {
+         if (clipcnt == 0 || clipped[clipcnt - 1] != xx) {
+            clipped[clipcnt++] = xx;
+         }
+      }
+      h1 = GetWaveYPos(v, zoomMin, zoomMax,
+                       r.height, dB, true, mdBrange, true);
+
+      v = max[x] * env[x];
+      if (mShowClipping && v >= MAX_AUDIO) {
+         if (clipcnt == 0 || clipped[clipcnt - 1] != xx) {
+            clipped[clipcnt++] = xx;
+         }
+      }
+      h2 = GetWaveYPos(v, zoomMin, zoomMax,
+                       r.height, dB, true, mdBrange, true);
+
+      // JKC: This adjustment to h1 and h2 ensures that the drawn
+      // waveform is continuous.
+      if (x > 0) {
+         if (h1 < lasth2) {
+            h1 = lasth2 - 1;
+         }
+         if (h2 > lasth1) {
+            h2 = lasth1 + 1;
+         }
+      }
+      lasth1 = h1;
+      lasth2 = h2;
+
+      r1[x] = GetWaveYPos(-rms[x] * env[x], zoomMin, zoomMax,
+                          r.height, dB, true, mdBrange, true);
+      r2[x] = GetWaveYPos(rms[x] * env[x], zoomMin, zoomMax,
+                          r.height, dB, true, mdBrange, true);
+
+      // Make sure the rms isn't larger than the waveform min/max
+      if (r1[x] > h1 - 1) {
+         r1[x] = h1 - 1;
+      }
+      if (r2[x] < h2 + 1) {
+         r2[x] = h2 + 1;
+      }
+      if (r2[x] > r1[x]) {
+         r2[x] = r1[x];
+      }
+
+      if (bl[x] <= -1) {
+         if (drawStripes) {
+            // TODO:unify with buffer drawing.
+            dc.SetPen((bl[x] % 2) ? muteSamplePen : samplePen);
+            for (int y = 0; y < r.height / 25 + 1; y++) {
+               // we are drawing over the buffer, but I think DrawLine takes care of this.
+               AColor::Line(dc,
+                            xx,
+                            r.y + 25 * y + (x /*+pixAnimOffset*/) % 25,
+                            xx, 
+                            r.y + 25 * y + (x /*+pixAnimOffset*/) % 25 + 6); //take the min so we don't draw past the edge
+            }
+         }
+         
+         // draw a dummy waveform - some kind of sinusoid.  We want to animate it so the user knows it's a dummy.  Use the second's unit of a get time function.
+         // Lets use a triangle wave for now since it's easier - I don't want to use sin() or make a wavetable just for this.
+         if (drawWaveform) {
+            int triX;
+            dc.SetPen(samplePen);
+            triX = fabs((double)((x + pixAnimOffset) % (2 * r.height)) - r.height) + r.height;
+            for (int y = 0; y < r.height; y++) {
+               if ((y + triX) % r.height == 0) {
+                  dc.DrawPoint(xx, r.y + y);
+               }
+            }
+         }
+      }
+      else {
+         AColor::Line(dc, xx, r.y + h2, xx, r.y + h1);
+      }
+   }
+
+   dc.SetPen(muted ? muteRmsPen : rmsPen);
+   for (int x = 0; x < r.width; x++) {
+      int xx = r.x + x;
+      if (bl[x] <= -1) {
+      }
+      else if (r1[x] != r2[x]) {
+         AColor::Line(dc, xx, r.y + r2[x], xx, r.y + r1[x]);
+      }
+   }
+
+   // Draw the clipping lines
+   if (clipcnt) {
+      dc.SetPen(muted ? muteClippedPen : clippedPen);
+      while (--clipcnt >= 0) {
+         int xx = clipped[clipcnt];
+         AColor::Line(dc, xx, r.y, xx, r.y + r.height);
+      }
+   }
+
+   if (mShowClipping) {
+      delete[] clipped;
+   }
+
+   delete [] r1;
+   delete [] r2;
+}
+
+void WaveTrackV::DrawIndividualSamples(wxDC &dc, const wxRect &r,
+                                        float zoomMin, float zoomMax, bool dB,
+                                        WaveClip *clip,
+                                        double t0, double pps, double h,
+                                        bool drawSamples, bool showPoints, bool muted)
+{
+   double rate = clip->GetRate();
+   sampleCount s0 = (sampleCount) (t0 * rate + 0.5);
+   sampleCount slen = (sampleCount) (r.width * rate / pps + 0.5);
+   sampleCount snSamples = clip->GetNumSamples(); 
+   
+   slen += 4;
+
+   if (s0 > snSamples) {
+      return;
+   }
+
+   if (s0 + slen > snSamples) {
+      slen = snSamples - s0;
+   }
+
+   float *buffer = new float[slen];
+   clip->GetSamples((samplePtr)buffer, floatSample, s0, slen);
+
+   int *xpos = new int[slen];
+   int *ypos = new int[slen];
+   int *clipped = NULL;
+   int clipcnt = 0;
+   sampleCount s;
+
+   if (mShowClipping) {
+      clipped = new int[slen];
+   }
+
+   dc.SetPen(muted ? muteSamplePen : samplePen);
+   
+   for (s = 0; s < slen; s++) {
+      double tt = (s / rate);
+
+      // MB: (s0/rate - t0) is the distance from the left edge of the screen
+      //     to the first sample.
+      int xx = (int)rint((tt + s0 / rate - t0) * pps);
+      
+      if (xx < -10000) {
+         xx = -10000;
+      }
+      if (xx > 10000) {
+         xx = 10000;
+      }
+      
+      xpos[s] = xx;
+
+      // t0 + clip->GetOffset() is 'h' (the absolute time of the left edge) for 'r'.
+      tt = buffer[s] * clip->GetEnvelope()->GetValueAtX(xx + r.x, r, t0 + clip->GetOffset(), pps);
+      if (mShowClipping && (tt <= -MAX_AUDIO || tt >= MAX_AUDIO)) {
+         clipped[clipcnt++] = xx;
+      }
+      ypos[s] = GetWaveYPos(tt, zoomMin, zoomMax,
+                            r.height, dB, true, mdBrange, false);
+      if (ypos[s] < -1) {
+         ypos[s] = -1;
+      }
+      if (ypos[s] > r.height) {
+         ypos[s] = r.height;
+      }
+   }
+
+   // Draw lines
+   for (s = 0; s < slen - 1; s++) {
+      AColor::Line(dc,
+                   r.x + xpos[s], r.y + ypos[s],
+                   r.x + xpos[s + 1], r.y + ypos[s + 1]);
+   }
+
+   if (showPoints) {
+      // Draw points
+      int tickSize= drawSamples ? 4 : 3;// Bigger ellipses when draggable.
+      wxRect pr;
+      pr.width = tickSize;
+      pr.height = tickSize;
+      //different colour when draggable.
+      dc.SetBrush( drawSamples ? dragsampleBrush : sampleBrush);
+      for (s = 0; s < slen; s++) {
+         if (ypos[s] >= 0 && ypos[s] < r.height) {
+            pr.x = r.x + xpos[s] - tickSize/2;
+            pr.y = r.y + ypos[s] - tickSize/2;
+            dc.DrawEllipse(pr);
+         }
+      }
+   }
+
+   // Draw clipping
+   if (clipcnt) {
+      dc.SetPen(muted ? muteClippedPen : clippedPen);
+      while (--clipcnt >= 0) {
+         s = clipped[clipcnt];
+         AColor::Line(dc, r.x + s, r.y, r.x + s, r.y + r.height);
+      }
+   }
+   
+   if (mShowClipping) {
+      delete [] clipped;
+   }
+
+   delete[]buffer;
+   delete[]xpos;
+   delete[]ypos;
+}
+
+void WaveTrackV::DrawEnvelope(wxDC &dc, const wxRect &r, const double env[],
+                               float zoomMin, float zoomMax, bool dB)
+{
+   int h = r.height;
+
+   dc.SetPen(AColor::envelopePen);
+
+   for (int x = 0; x < r.width; x++) {
+      int cenvTop = GetWaveYPos(env[x], zoomMin, zoomMax,
+                                h, dB, true, mdBrange, true);
+
+      int cenvBot = GetWaveYPos(-env[x], zoomMin, zoomMax,
+                                h, dB, true, mdBrange, true);
+
+      int envTop = GetWaveYPos(env[x], zoomMin, zoomMax,
+                               h, dB, true, mdBrange, false);
+
+      int envBot = GetWaveYPos(-env[x], zoomMin, zoomMax,
+                               h, dB, true, mdBrange, false);
+
+      // Make the collision at zero actually look solid
+      if (cenvBot - cenvTop < 9) {
+         int value = (int)((zoomMax / (zoomMax - zoomMin)) * h);
+         cenvTop = value - 4;
+         cenvBot = value + 4;
+      }
+
+      DrawEnvLine(dc, r, x, envTop, cenvTop, true);
+      DrawEnvLine(dc, r, x, envBot, cenvBot, false);
+   }
+}
+
+void WaveTrackV::DrawEnvLine(wxDC &dc, const wxRect &r, int x, int y, int cy, bool top)
+{
+   int xx = r.x + x;
+   int yy = r.y + cy;
+
+   if (y < 0) {
+      if (x % 4 != 3) {
+         AColor::Line(dc, xx, yy, xx, yy + 3);
+      }
+   }
+   else if (y > r.height) {
+      if (x % 4 != 3) {
+         AColor::Line(dc, xx, yy - 3, xx, yy);
+      }
+   }
+   else {
+      if (top) {
+         AColor::Line(dc, xx, yy, xx, yy + 3);
+      }
+      else {
+         AColor::Line(dc, xx, yy - 3, xx, yy);
+      }
+   }
+}
+
+void WaveTrackV::DrawTimeSlider(WaveTrack *track,
+                                 wxDC & dc,
+                                 const wxRect & r,
+                                 const ViewInfo *viewInfo,
+                                 bool rightwards)
+{
+   const int border = 3; // 3 pixels all round.
+   const int width = 6; // width of the drag box.
+   const int taper = 6; // how much the box tapers by.
+   const int barSpacing = 4; // how far apart the bars are.
+   const int barWidth = 3;
+   const int xFlat = 3;
+
+   //Enough space to draw in?
+   if (r.height <= ((taper+border + barSpacing) * 2)) {
+      return;
+   }
+   if (r.width <= (width * 2 + border * 3)) {
+      return;
+   }
+
+   // The draggable box is tapered towards the direction you drag it.
+   int leftTaper  = rightwards ? 0 : 6;
+   int rightTaper = rightwards ? 6 : 0;
+
+   int xLeft = rightwards ? (r.x + border - 2)
+                          : (r.x + r.width + 1 - (border + width));
+   int yTop  = r.y + border;
+   int yBot  = r.y + r.height - border - 1;
+
+   AColor::Light(&dc, false);
+   AColor::Line(dc, xLeft,         yBot - leftTaper, xLeft,         yTop + leftTaper);
+   AColor::Line(dc, xLeft,         yTop + leftTaper, xLeft + xFlat, yTop);
+   AColor::Line(dc, xLeft + xFlat, yTop,             xLeft + width, yTop + rightTaper);
+
+   AColor::Dark(&dc, false);
+   AColor::Line(dc, xLeft + width,         yTop + rightTaper, xLeft + width,       yBot - rightTaper);
+   AColor::Line(dc, xLeft + width,         yBot - rightTaper, xLeft + width-xFlat, yBot);
+   AColor::Line(dc, xLeft + width - xFlat, yBot,              xLeft,               yBot - leftTaper);
+
+   int firstBar = yTop + taper + taper / 2;
+   int nBars    = (yBot - yTop - taper * 3) / barSpacing + 1;
+   xLeft += (width - barWidth + 1) / 2;
+   int y;
+   int i;
+
+   AColor::Light(&dc, false);
+   for (i = 0;i < nBars; i++) {
+      y = firstBar + barSpacing * i;
+      AColor::Line(dc, xLeft, y, xLeft + barWidth, y);
+   }
+   AColor::Dark(&dc, false);
+   for(i = 0;i < nBars; i++){
+      y = firstBar + barSpacing * i + 1;
+      AColor::Line(dc, xLeft, y, xLeft + barWidth, y);
+   }
+}
+
+// Draws the sync-lock bitmap, tiled; always draws stationary relative to the DC
+//
+// AWD: now that the tiles don't link together, we're drawing a tilted grid, at
+// two steps down for every one across. This creates a pattern that repeats in
+// 5-step by 5-step boxes. Because we're only drawing in 5/25 possible positions
+// we have a grid spacing somewhat smaller than the image dimensions. Thus we
+// acheive lower density than with a square grid and eliminate edge cases where
+// no tiles are displayed.
+//
+// The pattern draws in tiles at (0,0), (2,1), (4,2), (1,3), and (3,4) in each
+// 5x5 box.
+//
+// There may be a better way to do this, or a more appealing pattern.
+void WaveTrackV::DrawSyncLockTiles(wxDC *dc, wxRect r)
+{
+   wxBitmap syncLockBitmap(theTheme.Image(bmpSyncLockSelTile));
+
+   // Grid spacing is a bit smaller than actual image size
+   int gridW = syncLockBitmap.GetWidth() - 6;
+   int gridH = syncLockBitmap.GetHeight() - 8;
+
+   // Horizontal position within the grid, modulo its period
+   int blockX = (r.x / gridW) % 5;
+   
+   // Amount to offset drawing of first column
+   int xOffset = r.x % gridW;
+   if (xOffset < 0) xOffset += gridW;
+
+   // Check if we're missing an extra column to the left (this can happen
+   // because the tiles are bigger than the grid spacing)
+   bool extraCol = false;
+   if (syncLockBitmap.GetWidth() - gridW > xOffset) {
+      extraCol = true;
+      xOffset += gridW;
+      blockX = (blockX - 1) % 5;
+   }
+   // Make sure blockX is non-negative
+   if (blockX < 0) blockX += 5;
+   
+   int x = 0;
+   while (x < r.width) {
+      int width = syncLockBitmap.GetWidth() - xOffset;
+      if (x + width > r.width)
+         width = r.width - x;
+
+      //
+      // Draw each row in this column
+      //
+
+      // Vertical position in the grid, modulo its period
+      int blockY = (r.y / gridH) % 5;
+
+      // Amount to offset drawing of first row
+      int yOffset = r.y % gridH;
+      if (yOffset < 0) yOffset += gridH;
+      
+      // Check if we're missing an extra row on top (this can happen because
+      // the tiles are bigger than the grid spacing)
+      bool extraRow = false;
+      if (syncLockBitmap.GetHeight() - gridH > yOffset) {
+         extraRow = true;
+         yOffset += gridH;
+         blockY = (blockY - 1) % 5;
+      }
+      // Make sure blockY is non-negative
+      if (blockY < 0) blockY += 5;
+
+      int y = 0;
+      while (y < r.height)
+      {
+         int height = syncLockBitmap.GetHeight() - yOffset;
+         if (y + height > r.height)
+            height = r.height - y;
+
+         // AWD: draw blocks according to our pattern
+         if ((blockX == 0 && blockY == 0) || (blockX == 2 && blockY == 1) ||
+             (blockX == 4 && blockY == 2) || (blockX == 1 && blockY == 3) ||
+             (blockX == 3 && blockY == 4))
+         {
+
+            // Do we need to get a sub-bitmap?
+            if (width != syncLockBitmap.GetWidth() || height != syncLockBitmap.GetHeight()) {
+               wxBitmap subSyncLockBitmap = 
+                  syncLockBitmap.GetSubBitmap(wxRect(xOffset, yOffset, width, height));
+               dc->DrawBitmap(subSyncLockBitmap, r.x + x, r.y + y, true);
+            }
+            else {
+               dc->DrawBitmap(syncLockBitmap, r.x + x, r.y + y, true);
+            }
+         }
+
+         // Updates for next row
+         if (extraRow) {
+            // Second offset row, still at y = 0; no more extra rows
+            yOffset -= gridH;
+            extraRow = false;
+         }
+         else {
+            // Move on in y, no more offset rows
+            y += gridH - yOffset;
+            yOffset = 0;
+         }
+         blockY = (blockY + 1) % 5;
+      }
+
+      // Updates for next column
+      if (extraCol) {
+         // Second offset column, still at x = 0; no more extra columns
+         xOffset -= gridW;
+         extraCol = false;
+      }
+      else {
+         // Move on in x, no more offset rows
+         x += gridW - xOffset;
+         xOffset = 0;
+      }
+      blockX = (blockX + 1) % 5;
+   }
+}
+
+/// Takes a value between min and max and returns a value between 
+/// height and 0 
+/// \todo  Should this function move int GuiWaveTrack where it can
+/// then use the zoomMin, zoomMax and height values without having 
+/// to have them passed in to it??
+int GetWaveYPos(float value, float min, float max,
+                int height, bool dB, bool outer,
+                float dBr, bool clip)
+{
+   if (dB) {
+      if (height == 0) {
+         return 0;
+      }
+
+      float sign = (value >= 0 ? 1 : -1);
+
+      if (value != 0.) {
+         float db = 20.0 * log10(fabs(value));
+         value = (db + dBr) / dBr;
+         if (!outer) {
+            value -= 0.5;
+         }
+         if (value < 0.0) {
+            value = 0.0;
+         }
+         value *= sign;
+      }
+   }
+   else {
+      if (!outer) {
+         if (value >= 0.0) {
+            value -= 0.5;
+         }
+         else {
+            value += 0.5;
+         }
+      }
+   }
+
+   if (clip) {
+      if (value < min) {
+         value = min;
+      }
+      if (value > max) {
+         value = max;
+      }
+   }
+
+   value = (max - value) / (max - min);
+   return (int) (value * (height - 1) + 0.5);
+}
+
